*******************************************************************************
*                      68000/68010 Grundprogramm Menue                        *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2007 Jens Mewes                                 *
*                                 Rev 7.00                                    *
*                                01.09.2007                                   *
*                              Mensteuerung                                  *
*******************************************************************************


grund:                          * Menpunkte aufrufen
 movem.l d0-d7/a0-a6,-(a7)      * Register retten
 move.b menflag(a5),-(a7)       * menflag auch
 tst d0
 bmi.s grund1                   * d0 negativ bedeutet eine bestimmte Routine
 or.b #%10000100,d0             * Bits in menflag setzen
 move.b d0,menflag(a5)          * Bit 0 gibt Menform an
 bsr smenue                      * Mensteuerung aufrufen
bra.s grund2                    * Ende

grund1:
 bclr.b #7,menflag(a5)          * Keine Hardcopy bei Einzelprogrammen
 neg d0                         * Negieren
 subq #1,d0                     * Bereich 1..33
 cmp #maxgrund,d0
 bhi.s grund2                   * Zu gro, kein Programm
 add d0,d0
 move grundtab(pc,d0),d0
 jsr grundtab(pc,d0)            * Programm aufrufen, da Adressberechnung OK
grund2:
 move.b (a7)+,menflag(a5)       * menflag zurck
 movem.l (a7)+,d0-d7/a0-a6      * Register zurck
rts

grundtab:                       * d0 = -X
 dc.w aendere-grundtab          * 1
 dc.w startex-grundtab          * 2
 dc.w speicheraus-grundtab      * 3
 dc.w symbolaus-grundtab        * 4
 dc.w edit-grundtab             * 5
 dc.w mass-grundtab             * 6
 dc.w bibo-grundtab             * 7
 dc.w loaddisk-grundtab         * 8
 dc.w savedisk-grundtab         * 9
 dc.w inhdisk-grundtab          * 10
 dc.w deldatei-grundtab         * 11
 dc.w kopdatei-grundtab         * 12
 dc.w rendatei-grundtab         * 13
 dc.w boot-grundtab             * 14
 dc.w promwrite-grundtab        * 15
 dc.w promread-grundtab         * 16
 dc.w ausspber-grundtab         * 17
 dc.w druckmen-grundtab         * 18
 dc.w ioread-grundtab           * 19
 dc.w iowrite-grundtab          * 20
 dc.w einzel-grundtab           * 21
 dc.w sysmen-grundtab           * 22
 dc.w textalt-grundtab          * 23
 dc.w textneu-grundtab          * 24
 dc.w symloe-grundtab           * 25
 dc.w groess21-grundtab         * 26
 dc.w groess11-grundtab         * 27
 dc.w debugein-grundtab         * 28
 dc.w debugaus-grundtab         * 29
 dc.w erraus-grundtab           * 30
 dc.w crtex-grundtab            * 31
 dc.w lstex-grundtab            * 32
 dc.w lstolf-grundtab           * 33

grundtend:

maxgrund equ (grundtend-grundtab)/2

start:                          * Grundprogramm Start beim Einschalten / Reset
 tst.b $7000.w                  * BOOT-Karte lschen
 move.w #$8080,bankboot.w       * Beide BANKBOOT-Karten lschen
 lea basis(pc),a5
 adda.l ramstart(pc),a5         * a5 als Zeiger auf Variablen setzen
 lea stack(a5),a7               * Dummy Stack
 bsr init                       * Variablen init / Copyright ausgeben
 movea.l d0,a7                  * Stack festlegen (Wird in d0 zurckgegeben)
warmstart:
 cmp.l #$a140557a,bootflag(a5)
 beq.s smenue                   * Wenn Computer schon an war, dann weiter
 move.l #$a140557a,bootflag(a5) * Flag, da Bootvorgang erfolgte
 btst.b #1,keydil(a5)           * DIL-Schalter 1 auf Key angeschaltet ?
 beq.s smenue                   * Nein, dann normaler Start
 bsr autoboot                   * Ja, dann mit Bootmen beginnen

smenue:                         * Spezialmen mit allen Teilen auf einer Seite
 bsr clrall                     * Bildschirm lschen
 moveq #$ff,d7                  * Achtung !!! d7 ist lokaler Sekundenmerker
 lea menue(pc),a0
 moveq #$33,d0
 move #220,d2
 bsr centertxt                  * berschrift
 lea smentxt(pc),a0
 moveq #$21,d0
 moveq #5,d1
 move #206,d2
 bsr textprint                  * Men Teil 1
 lea smentxt0(pc),a0
 move #269,d1
 bsr textprint
 btst.b #2,menflag(a5)
 beq.s smen1                    * Grundprogramm nicht als Aufruf, dann weiter
 lea smentxt1(pc),a0
 moveq #$21,d0
 move #269,d1
 moveq #126,d2
 bsr textprint                  * Da Grundprogramm als Aufruf mit 'Z = BEENDEN'
smen1:
 lea smentxt4(pc),a0            * 1. Infozeile
 lea ausbuf(a5),a1              * Nach ausbuf bringen
smen2:
 move.b (a0)+,(a1)+             * bertragen bis Null
 bne.s smen2
 lea ausbuf+10(a5),a0
 move.l stxtxt(a5),d0
 bsr print8x                    * Editoranfangsadresse einfgen
 move.b #' ',(a0)
 lea ausbuf+30(a5),a0
 move.l etxtxt(a5),d0
 bsr print8x                    * Editorendadresse
 move.b #' ',(a0)
 lea symtab(a5),a0
 move.l a0,d0
 lea ausbuf+50(a5),a0
 bsr print8x                    * Symboltabellenstart
 move.b #' ',(a0)
 moveq #0,d0
 move symnext(a5),d0
 lea symtab(a5),a0
 add.l a0,d0
 lea ausbuf+70(a5),a0
 bsr print8x                    * Symboltabellenende
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #5,d1
 moveq #13,d2
 bsr textaus                    * Zeile ausgeben
 moveq #83,d3
 bsr umrande                    * Mit Umrandung
smen3:
 lea smentxt2(pc),a0            * 2. Infozeile
 lea ausbuf+2(a5),a1
smen4:
 move.b (a0)+,(a1)+
 bne.s smen4                    * Auch bertragen
 subq.l #1,a1                   * Null ignorieren
 moveq #0,d0
 move.b iostat(a5),d0           * Ausgabe-Kanal holen
 lsl #4,d0                      * Fr Textberechnung
 lea smentxt3-16(pc),a0         * -16, da iostat Bereich  1..6 hat
 adda.l d0,a0                   * Adresse Text berechnet
smen5:
 move.b (a0)+,(a1)+             * bertragen
 bne.s smen5
 clr d1
 move.b groesse(a5),d1
 lsr #4,d1                      * X-Gre holen
 bne.s smen50
 moveq #16,d1                   * Null ist Vergrerung 16
smen50:
 moveq #80,d0
 divs d1,d0                     * Zeichen pro Zeile berechnen
 lea ausbuf(a5),a0
 bsr print4d                    * Und in Infozeile einfgen
 move.b #' ',(a0)
 tst.b debug(a5)
 beq.s smen6                    * Debug aus, dann nichts ndern
 move.l #'an  ',ausbuf+32(a5)   * Text, da Debug an ist einfgen
smen6:
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #5,d1
 moveq #2,d2
 bsr textaus                    * 2. Infozeile ausgeben
 moveq #83,d3
 bsr umrande                    * Mit Umrandung
smen7:
 tst.b uhrausw(a5)
 beq.s smen8                    * Keine Uhr an, dann weiter
 lea einbuf(a5),a0
 bsr getuhr                     * Uhrzeit holen
 move.b einbuf+6(a5),d0
 cmp.b d7,d0
 beq.s smen8                    * Alte Zeit = Neue Zeit, dann nicht ausgeben
 move.b d0,d7                   * Sekunden merken
 lea ausbuf(a5),a0
 moveq #2,d0                    * Anzahl Buchstaben fr Tag
 bsr uhrprt0                    * Uhrzeit umwandeln
 lea ausbuf(a5),a0
 moveq #$11,d0
 move #365,d1
 moveq #2,d2
 bsr textaus                    * Uhrzeit ausgeben
smen8:
 bsr csts                       * Zeichen von Tastatur da
 beq.s smen7                    * Ja, weiter
 bsr ki                         * Zeichen als Grobuchstaben holen
 btst.b #2,menflag(a5)
 beq.s smen9                    * Grundprogramm als Aufruf, dann weiter
 cmp.b #'Z',d0                  * Sonst ist 'Z' nicht erlaubt
 bne.s smen9
rts
smen9:
 cmp.b #':',d0                  * Kleiner als ':', dann Optionen
 bmi.s smen10
 cmp.b #'A',d0                  * Kleiner als 'A', dann Fehler
 bmi smen7
 cmp.b #'Y',d0                  * Grer als 'Y', dann auch Fehler
 bhi smen7
 lea grundtab-'A'(pc),a1
 add d0,d0
 move -'A'(a1,d0),d1
 jsr 'A'(a1,d1)                 * Programm anspringen
bra smenue                      * Zurck

smen10:
 sub.b #'0',d0
 bmi smen7                      * Kleiner als Null, dann Fehler
 bsr.s smenue1
bra smen3

smenue1:
 tst.b d0                       * Maus an/aus
 bne.s smenue10
 rts
 
smenue10:
 cmp.b #1,d0
 beq groess21                   * 40 Zeichen pro Zeile
 cmp.b #2,d0
 beq groess11                   * 80 Zeichen pro Zeile
 cmp.b #3,d0
 beq debugein                   * Debug an
 cmp.b #4,d0
 beq debugaus                   * Debug aus
 cmp.b #9,d0
 beq.s smenue2                  * Uhr stellen
 subq.b #4,d0
 move.b d0,iostat(a5)           * Ausgabekanal whlen
rts

smen2tab:                       * X-Pos, Nummer Zeichen, untere Grenze, obere Gr
 dc.w 365,5,1,7
 dc.w 389,2,1,31
 dc.w 407,3,1,12
 dc.w 425,4,0,99
 dc.w 449,0,0,23
 dc.w 467,1,0,59
 dc.w 485,6,0,59

smenue2:
 tst.b uhrausw(a5)
 beq carset                     * Keine Uhr an, dann Ende
 lea einbuf(a5),a0
 bsr getuhr                     * Uhrzeit holen
 lea smen2tab(pc),a6
 moveq #7-1,d7                  * 7 Werte holen
smenue21:
 movem (a6),d1/d2               * Daten holen
 lea einbuf(a5),a4
 adda.l d2,a4                   * Position des Uhrzeitwertes in einbuf
 move.b (a4),d0
 lea ausbuf(a5),a0
 bsr print2x                    * Alten Wert in ASCII wandeln
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #2,d2
 moveq #0,d3
 bsr readaus                    * Wert ndern
 bcs carset                     * Abbruch
 lea ausbuf(a5),a0
 bsr wertmfeh                   * Wert berechnen
 bcs.s smenue21                 * Fehler
 movem 4(a6),d2/d3              * Vergleichswerte fr obere und untere Grenze
 cmp d2,d0
 bmi.s smenue21                 * Falscher Wert
 cmp d0,d3
 bmi.s smenue21                 * Falscher Wert
 divu #10,d0
 move.b d0,d1
 lsl.b #4,d1
 swap d0
 add.b d1,d0
 move.b d0,(a4)                 * In BCD-Code gewandelt
 addq.l #8,a6                   * Tabelle weiter
dbra d7,smenue21
 moveq #$ff,d7                  * Sekundenmerker rcksetzen
 lea einbuf(a5),a0
bra setuhr                      * Uhrzeit setzen

lstolf:
 move.b #4,iostat(a5)           * Auf Drucker ohne LF
rts

mass:
 bsr assemble                   * Assembler aufrufen
bra finmenue                    * Ende

sysmen:                         * System Konfiguration
 lea systxt0(pc),a0
 bsr headaclr                   * berschrift
 cmp.b #3, uhrausw(a5)          * NVRAM Daten?
 beq.s sysmen2
 lea systxt00(pc),a0            * Text: Kein NVRAM vorhanden
 moveq #$21,d0
 moveq #5,d1
 move #191,d2
 bsr textprint                  * Befehlsliste
sysmen1:
 bsr csts                       * Zeichen von Tastatur da
 beq.s sysmen1                  * Nein, nochmal
 bra carset                     * zurck
sysmen2:
 lea idebuff+32(a5), a2
 move #23-1, d3
 lea systxt1(pc),a0
 moveq #$21,d0
 moveq #5,d1
 move #191,d2
 bsr textprint                  * Befehlsliste
 lea nvrbuff(a5), a0
 cmp #$a5c3, (a0)               * Pufferdaten gltig?
 bne.s sysmen3a                 * nein
 lea idebuff(a5), a1
 move #32-1, d3
sysmen2a:
 move.b (a0)+, (a1)+
 dbra d3, sysmen2a
 bra.s sysmen3
sysmen3a:
 lea idebuff(a5), a0
 bsr initnvrb                   * sonst default Werte
sysmen3:
 move #191, d2
 bsr syszloe                    * Zeile lschen 
 lea ausbuf(a5), a0
 move.b #'%', (a0)
 clr.b 1(a0)
 move.b #$21, d0
 move #221, d1
 move #191, d2
 bsr textprint                  * '%' Ausgeben
 lea idebuff(a5), a1
 move.b 2(a1), d0
 lea ausbuf(a5), a0
 bsr print8b
 lea ausbuf(a5), a0
 move.b #$21, d0
 move #233, d1
 move #191, d2
 bsr textprint                  * DIP-Key Ausgabe
 move #171, d2
 bsr syszloe                    * Zeile lschen 
 lea ausbuf(a5), a0
 addq.l #4, a1
 moveq #4-1, d3
 bsr sysmenw
 lea ausbuf(a5), a0
 move.b #$21, d0
 move #221, d1
 move #171, d2
 bsr textprint                  * Autoboot Ausgabe
 move #151, d2
 bsr syszloe                    * Zeile lschen 
 lea ausbuf(a5), a0
 moveq #2-1, d3
 bsr sysmenw
 lea ausbuf(a5), a0
 move.b #$21, d0
 move #221, d1
 move #151, d2
 bsr textprint                  * SER Ausgabe
 move #131, d2
 bsr syszloe                    * Zeile lschen 
 lea ausbuf(a5), a0
 moveq #6-1, d3
 bsr sysmenw
 lea ausbuf(a5), a0
 move.b #$21, d0
 move #221, d1
 move #131, d2
 bsr textprint                  * SER2 Kanal A Ausgabe
 move #111, d2
 bsr syszloe                    * Zeile lschen 
 lea ausbuf(a5), a0
 moveq #6-1, d3
 bsr sysmenw
 lea ausbuf(a5), a0
 move.b #$21, d0
 move #221, d1
 move #111, d2
 bsr textprint                  * SER2 Kanal B Ausgabe
sysmen4:
 lea einbuf(a5),a0
 moveq #$21,d0
 moveq #5,d1
 moveq #4,d2
 moveq #1,d3                    * Nur ein Zeichen
 bsr textein                    * Befehl einlesen
 bcs carset                     * Abbruch
 move d5,d0
 bsr bucheck                    * In Grobuchstaben wandeln
 cmp.b #'A', d0
 beq sysmena                    * 'A' = DIP-Key
 cmp.b #'B', d0
 beq sysmenb                    * 'B' = Autoboot
 cmp.b #'C', d0
 beq sysmenc                    * 'C' = SER
 cmp.b #'D', d0
 beq sysmend                    * 'D' = SER2 Kanal A
 cmp.b #'E', d0
 beq sysmene                    * 'E' = SER2 Kanal B
 cmp.b #'S', d0
 beq sysmens                    * 'S' = Speichern
 cmp.b #'Z', d0
 beq carres                     * 'Z' = Zurck
 bra.s sysmen4

sysmena:
 lea idebuff+2(a5), a1
 move #221,d6                   * X
 move #191,d2                   * Y
 moveq #9,d3                    * Anzahl der Zeichen maximal
 moveq #1-1,d7                  * Maximal 1 Zeichen
 bsr sysmenx
 bra sysmen3

sysmenb:
 lea idebuff+4(a5),a1           * Ziel fr Befehle
 move #221,d6                   * X
 move #171,d2                   * Y
 moveq #3,d3                    * Anzahl der Zeichen maximal
 moveq #4-1,d7                  * Maximal 4 Zeichen
 bsr sysmenx
 bra sysmen3

sysmenc:
 lea idebuff+8(a5),a1           * Ziel fr Befehle
 move #221,d6                   * X
 move #151,d2                   * Y
 moveq #3,d3                    * Anzahl der Zeichen maximal
 moveq #2-1,d7                  * Maximal 2 Zeichen
 bsr sysmenx
 bra sysmen3

sysmend:
 lea idebuff+10(a5),a1          * Ziel fr Befehle
 move #221,d6                   * X
 move #131,d2                   * Y
 moveq #3,d3                    * Anzahl der Zeichen maximal
 moveq #6-1,d7                  * Maximal 6 Zeichen
 bsr sysmenx
 bra sysmen3

sysmene:
 lea idebuff+16(a5),a1          * Ziel fr Befehle
 move #221,d6                   * X
 move #111,d2                   * Y
 moveq #3,d3                    * Anzahl der Zeichen maximal
 moveq #6-1,d7                  * Maximal 6 Zeichen
 bsr sysmenx
 bra sysmen3

sysmens:
 lea idebuff(a5), a1
 lea nvrbuff(a5), a0
 move #32-1, d3
sysmens1:
 move.b (a1)+, (a0)+
 dbra d3, sysmens1
 lea nvrbuff(a5), a0
 bsr setsys
 lea nvrbuff(a5), a0
 move #$a5c3, (a0)
 bra carres

sysmenw:
 move.b #'$', (a0)+
 move.b (a1)+, d0
 bsr print2x
 move.b #' ', (a0)+
 dbra d3, sysmenw
 move.b #0, -1(a0)              * Endnull schreiben
 rts

sysmenx:
 lea einbuf(a5),a0
 moveq #$21,d0
 move d6,d1
 bsr textein                    * Zeichen lesen
 bcs.s sysmenx1                 * Ende
 tst d4
 beq.s sysmenx1                 * Ende
 lea einbuf(a5),a0
 bsr wertmfeh                   * Wert berechnen
 bcs.s sysmenx                  * Fehler, noch einmal eingeben
 move.b d0,(a1)+                * Wert ablegen
 add #48,d6                     * Neue Position
 dbra d7,sysmenx
sysmenx1:
 rts

syszloe:
 moveq #$21,d0                  * Schriftgre
 move #221,d1                   * X-Position
 bsr setprt                     * Werte einstellen
 bsr erapen                     * Auf Lschen
 moveq #%1010,d0                * Befehl fr Block
 moveq #20-1,d3                 * 20 Zeichen lschen
syszloe0:
 bsr cmd                        * Befehl an GDP
dbra d3,syszloe0
 bsr setpen
 rts

symloe:
 lea menue23(pc),a0             * Symbole lschen
 bsr menueio
 cmp.b #'1',d0
 beq symloesche                 * Lschen
rts

textalt:                        * Alten Text feststellen
 lea txtdefa(pc),a0
 bsr headaclr                   * berschrift
 bsr getadr                     * Adresse holen
 bcc putstx                     * Editor Variablen belegen
rts                             * Fehler bei Wert

textneu:                        * Neuen Editor einrichten
 lea txtdefn(pc),a0
 bsr headaclr                   * berschrift
 bsr getadr                     * Adresse holen
 bcs.s textn1                   * Fehler
 movea.l d0,a1                  * Adresse merken
 lea txtm2(pc),a0
 moveq #$22,d0
 moveq #20,d2
 bsr centertxt                  * Abfrage, ob wirklich neuer Text eingerichtet
 bsr ki                         * werden soll
 cmp.b #'J',d0
 bne.s textn1                   * Kein 'J', dann Abbruch
 move.l a1,stxtxt(a5)
 move.l a1,akttxt(a5)
 move.l a1,etxtxt(a5)           * Editor Variablen neu belegt
 clr.b (a1)                     * Null fr Endekennung
textn1:
rts

groess21:
 move.b #$21,groesse(a5)        * 40 Zeichen
rts

groess11:
 move.b #$11,groesse(a5)        * 80 Zeichen
rts

debugein:                       * Debug einstellen
 move.b #1,debug(a5)
initdebug:
 move.l etxtxt(a5),d0           * Ende der Texte
 addq.l #3,d0
 and.b #$fe,d0                  * Auf gerade Adresse bringen
 move.l d0,debugst(a5)
 move.l d0,debugak(a5)          * Debug Variablen
 movea.l d0,a0
 clr.l (a0)                     * Null ist Endekennung
rts

debugaus:
 clr.b debug(a5)                * Debug ausschalten
rts

autoboot:
 lea nvrbuff(a5), a0
 cmp #$a5c3, (a0)               * NVRAM Daten?
 bne.s autob01                  * nein
 adda.l #4, a0                  * auf Autoboot Daten
 bra.s autob02
autob01:
 lea boottab(pc), a0            * Boot-Reihenfolge-Tabelle
autob02:
 move #4-1, d3                  * 4 Eintrge in der Tabelle
autob03:
 move.b (a0)+, d0               * 
 bsr aboot
 bcc.b autobex                  * Boot war erfolgreich
 dbra d3, autob03
autobex:
 rts
 
aboot:
 cmp.b #3, d0
 bhi.s aboot01
 moveq #1,d4                    * Ein Bit
 lsl d0,d4                      * An die richtige Stelle schieben
 bsr floboot                    * Floppy
 bra.s abootex
aboot01:
 cmp.b #4, d0
 bhi.s aboot02
 bsr scsiboot                   * SCSI-Disk
 bra.s abootex
aboot02:
 cmp.b #5, d0
 bhi carset
 bsr ideboot1                   * IDE-Disk
abootex:
 rts

boottab:                        * wird nur verwendet, wenn kein NVRAM da
 dc.b 0, 4, 5, 3                * Bootreihenfolge: Floppy1, SCSI, IDE, SRAMDISK

boot:                           * Boot-Men
 tst.b flo2srd(a5)              * Floppy4 nach SRAMDISK aktiv?
 beq.b boota                    * nein
 lea menue34a(pc),a0
 bra.b bootb
boota:
 lea menue34(pc),a0
bootb:
 bsr menueio
 sub.b  #'1',d0
 cmp.b  #3,d0
 bhi.s hardboot                 * 0-3 ist Floppy-Boot
 moveq #1,d4                    * Ein Bit
 lsl d0,d4                      * An die richtige Stelle schieben

floboot:                        * Diskette booten in d4 steht Laufwerk
 bsr getflop                    * Floppy Format Laufwerk 1 feststellen
 bcs.s floboot1                 * Fehler oder keine Floppy geladen
 lea $1800(a5),a0               * Hinter Eprom laden
 moveq #1,d1
 moveq #1,d2
 moveq #0,d3
 bsr floppy                     * Spur 0, Sektor 1 lesen
 bcs.s floboot1
 moveq #0,d0                    * Kennung, da FLOPPY BOOT
 cmp #$4e71,(a0)                * Erster Befehl mu NOP sein fr BOOT Kennung
 bne.s floboot1                 * Fehler
floboot0:
 move.b menflag(a5),-(a7)       * menflag merken
 and.b #%01111011,menflag(a5)   * Kein Grundprogramm mehr
 jsr (a0)                       * Programm aufrufen
 bsr seta5                      * a5 wieder auf alten Wert setzen
 move.b (a7)+,menflag(a5)       * menflag zurck
bra carres                      * Boot wurde durchgefhrt
floboot1:
 move.b #$60,flo4.w             * Floppy-Motoren aus
bra carset                      * Boot wurde nicht ausgefhrt

hardboot:
 cmp.b  #4,d0                   * SCSI Disk-Boot
 bne.s  ideboot
 
scsiboot:
 clr.b scsi2ide(a5)             * SCSI nach IDE Umleitung loeschen
 moveq #1,d4                    * Harddisk 0
 bsr hardtest                   * Testen, ob vorhanden
 bcs carset                     * Nicht vorhanden
 cmp #2,d0
 beq.s scsiboot                 * Warte, bis Laufwerk richtig luft
 cmp #4,d0
 beq.s scsiboot                 * Warte, bis Laufwerk bereit
 lea $1800(a5),a0               * Zieladresse fr Daten
 clr (a0)                       * Sicherheitshalber
 moveq #1,d1                    * Sektor lesen
 moveq #0,d2                    * Sektor 0 lesen
 moveq #1,d3                    * Einen Sektor lesen
 bsr harddisk                   * Keine Fehlerabfrage, da zu aufwendig
 cmp #$4e71,(a0)
 bne carset                     * Fehler
 moveq #1,d0                    * Kennung fr HARDDISK-BOOT
bra.s floboot0

ideboot:
 cmp.b #5,d0                    * IDE Disk-Boot
 beq ideboot1
 bra carset

ideboot1:
 clr.b scsi2ide(a5)             * erstmal lschen
 moveq #1, d4                   * IDE Master Laufwerk
 bsr idetest                    * Testen, ob vorhanden
 bcs carset                     * IDE Disk nicht vorhanden
 lea $1800(a5),a0               * Zieladresse fr Daten
 clr (a0)                       * Sicherheitshalber
 moveq #1,d1                    * Sektor lesen
 moveq #0,d2                    * Sektor 0 lesen
 moveq #1,d3                    * Einen Sektor lesen
 bsr idedisk                    * Keine Fehlerabfrage, da zu aufwendig
 cmp #$4e71,(a0)                * NOP=NDR Boot?
 bne.s ideboota                 * nein
 lea $1a00(a5),a0               * Zieladresse fr 2.Sektor
 moveq #1, d2                   * Sektor 1 lesen
 bsr idedisk
 move.b #1, scsi2ide(a5)        * SCSI nach IDE Umleitung setzen
 moveq #1,d0                    * Kennung fr HARDDISK-BOOT
 lea $1800(a5),a0               * hier beginnt der Bootsektor
 bra.s idebootb
ideboota:
 cmp.w #$4e71, 4(a0)            * NOP als 3. Wort?
 bne carset                     * nein, dann nichts weiter tun
 moveq #1,d0                    * Kennung fr HARDDISK-BOOT
idebootb: 
 move.b menflag(a5),-(a7)       * menflag merken
 and.b #%01111011,menflag(a5)   * Kein Grundprogramm mehr
 jsr (a0)                       * Programm aufrufen
 bsr seta5                      * a5 zur Sicherheit auf alten Wert
 move.b (a7)+,menflag(a5)       * menflag zurck
 clr.b scsi2ide(a5)             * SCSI nach IDE Umleitung loeschen
bra carres                      * Boot wurde durchgefhrt

druckmen:                       * Druckersteuerung
 lea drtxt0(pc),a0
 bsr headaclr                   * berschrift
 lea drtxt1(pc),a0
 moveq #$21,d0
 moveq #5,d1
 move #207,d2
 bsr textprint                  * Befehlsliste
 bsr.s drall                    * Aktuelle Einstellungen
drmen0:
 lea einbuf(a5),a0
 moveq #$21,d0
 moveq #5,d1
 moveq #4,d2
 moveq #1,d3                    * Nur ein Zeichen
 bsr textein                    * Befehl einlesen
 bcs carset                     * Abbruch
 move d5,d0
 bsr bucheck                    * In Grobuchstaben wandeln
 cmp.b #'Z',d0
 beq carset                     * 'Z' = Zurck
 cmp.b #'A',d0                  * Bereich 'A'
 bmi.s drmen0
 cmp.b #'S',d0                  * bis 'S'
 bhi.s drmen0
 add d0,d0
 move drucktab-2*'A'(pc,d0.w),d1
 jsr drucktab(pc,d1.w)          * Befehl ausfhren
bra.s drmen0

drucktab:                       * Tabelle der Befehle zur Druckereinstellung
 dc.w drmena-drucktab           * Seitenlnge
 dc.w drmenb-drucktab           * Linker Rand
 dc.w drmenc-drucktab           * Druckart
 dc.w drmend-drucktab           * Schriftart
 dc.w drmene-drucktab           * Druck
 dc.w drmenf-drucktab           * Langsamer Druck
 dc.w drmeng-drucktab           * Fettdruck
 dc.w drmenh-drucktab           * Doppeldruck
 dc.w drmeni-drucktab           * Proportionaldruck
 dc.w drmenj-drucktab           * Kursivdruck
 dc.w drmenk-drucktab           * Papiererkennung
 dc.w drmenl-drucktab           * Zeichensatz
 dc.w drmenm-drucktab           * Kopienanzahl
 dc.w drmenn-drucktab           * Eigene Befehle
 dc.w drmeno-drucktab           * Werte rcksetzen
 dc.w initdr-drucktab           * Druckerinit
 dc.w drmenq-drucktab           * Seitenvorschub
 dc.w drmenr-drucktab           * Ausdrucken
 dc.w drbefneu-drucktab         * Druckerbefehle ndern

drmeno:                         * Werte rcksetzen
 move.b #2,dflag0(a5)
 clr.b dflag1(a5)
 move.b #65,dflag2(a5)
 clr.b dflag3(a5)

drall:                          * Druckereinstellungen ausgeben
 bsr.s drmenaa
 bsr.s drmenba
 bsr drmenca
 bsr drmenda
 bsr drmenea
 bsr drmenfa
 bsr drmenga
 bsr drmenha
 bsr drmenia
 bsr drmenja
 bsr drmenka
 bsr drmenla
 bsr drmenma
bra drmenna

drmena:                         * Seitenlnge
 addq.b #1,dflag2(a5)           * + 1
 and.b #$7f,dflag2(a5)          * Bis 127
 bne.s drmenaa
 addq.b #5,dflag2(a5)           * Von 5 an
drmenaa:
 moveq #0,d0
 move.b dflag2(a5),d0
 moveq #1,d2                    * Zeile 1
drmenab:
 lea ausbuf(a5),a0
 bsr print4d                    * In ASCII wandeln
 move.b #' ',(a0)+
 move.b #' ',(a0)+              * Falls Wechsel von 127 auf 5
 clr.b (a0)                     * Endekennung
 lea ausbuf(a5),a0
bra draus                       * Ausgeben

drmenb:                         * Linker Rand
 addq.b #1,dflag3(a5)           * + 1
 and.b #$7f,dflag3(a5)          * Bereich 0 bis 127
drmenba:
 moveq #0,d0
 move.b dflag3(a5),d0
 moveq #2,d2                    * Zeile 2
bra.s drmenab

drmenc:                         * Druckart
 btst.b #1,dflag1(a5)           * Drei Mglichkeiten (%00,%01,%10)
 beq.s drmenc0
 and.b #$fc,dflag1(a5)          * Nach %11 kommt wieder %00
bra.s drmenca
drmenc0:
 addq.b #1,dflag1(a5)           * Sonst 1 weiter
drmenca:
 lea drtxtc(pc),a0
 move.b dflag1(a5),d0
 and #3,d0                      * Bit 0 und 1
 mulu #7,d0                     * Jeweils 7 Buchstaben
 moveq #3,d2                    * Zeile 3
bra drausadd

drmend:                         * Schriftart
 bchg.b #2,dflag1(a5)           * Bit 2 bestimmt sie
drmenda:
 lea drtxtd(pc),a0
 move.b dflag1(a5),d0
 lsr #2,d0
 and #1,d0
 mulu #6,d0
 moveq #4,d2                    * Zeile 4
bra drausadd

drmene:                         * Druck
 bchg.b #3,dflag1(a5)           * Bit 3
drmenea:
 lea drtxte(pc),a0
 move.b dflag1(a5),d0
 lsr #3,d0
 and #1,d0
 mulu #15,d0
 moveq #5,d2                    * Zeile 5
bra drausadd

drmenf:                         * Langsamer Druck
 bchg.b #4,dflag1(a5)           * Bit 4
drmenfa:
 move.b dflag1(a5),d0
 lsr #2,d0
 moveq #6,d2                    * Zeile 6
bra drausand

drmeng:                         * Fettdruck
 bchg.b #7,dflag0(a5)           * Bit 7
drmenga:
 move.b dflag0(a5),d0
 lsr #5,d0
 moveq #7,d2                    * Zeile 7
bra drausand

drmenh:                         * Doppeldruck
 bchg.b #6,dflag0(a5)           * Bit 6
drmenha:
 move.b dflag0(a5),d0
 lsr #4,d0
 moveq #8,d2                    * Zeile 8
bra drausand

drmeni:                         * Proportionaldruck
 bchg.b #5,dflag0(a5)           * Bit 8
drmenia:
 move.b dflag0(a5),d0
 lsr #3,d0
 moveq #9,d2                    * Zeile 9
bra drausand

drmenj:                         * Kursivdruck
 bchg.b #4,dflag0(a5)           * Bit 4
drmenja:
 move.b dflag0(a5),d0
 lsr #2,d0
 moveq #10,d2                   * Zeile 10
bra.s drausand

drmenk:                         * Papiererkennung
 bchg.b #3,dflag0(a5)           * Bit 3
drmenka:
 move.b dflag0(a5),d0
 lsr #1,d0
 bchg   #2,d0                   * Wechseln da AN/AUS vertauscht
 moveq #11,d2                   * Zeile 11
bra.s drausand

drmenl:                         * Zeichensatz (%00,%01,%10)
 btst.b #1,dflag0(a5)           * Bit 1
 bne.s drmenl0
 addq.b #1,dflag0(a5)           * + 1
bra.s drmenla
drmenl0:
 and.b #$fc,dflag0(a5)          * Von %10 Wechsel auf %00
drmenla:
 lea drtxtl(pc),a0
 move.b dflag0(a5),d0
 and #3,d0
 mulu #13,d0
 moveq #12,d2                   * Zeile 12
bra.s drausadd

drmenm:                         * Anzahl Kopien
 cmp.b #%11011111,dflag1(a5)    * Bit 5-7
 bhi.s drmenm0                  * Wert ist 7
 add.b #%00100000,dflag1(a5)    * Nicht 7, also plus 1
bra.s drmenma
drmenm0:
 and.b #%00011111,dflag1(a5)    * Von 7 auf 0
drmenma:
 moveq #0,d0
 move.b dflag1(a5),d0
 lsr #5,d0
 lea ausbuf(a5),a0
 bsr print4d
 lea ausbuf(a5),a0
 moveq #13,d2
bra.s draus

drausand:                       * Ausgabe mit Addition d0,a0
 lea    drtxtf(pc),a0           * Text AN/AUS
 and #%00000100,d0              * Nur Bit 2 behalten ( Entweder Null oder 4 )
drausadd:                       * Nur Addition
 adda d0,a0

draus:                          * Info ausgeben d2 ist Zeile
 muls #-10,d2                   * Zeilenabstand
 add #217,d2                    * Berechnung oberste Zeile
 move #320,d1                   * X-Position
 moveq #$21,d0                  * Zeichengre
bra textaus                     * Text ausgeben

drmenn:
 lea drsave(a5),a1              * Ziel fr Befehle
 moveq #53,d6                   * X
 moveq #77,d2                   * Y
 moveq #3,d3                    * Anzahl der Zeichen maximal
 moveq #19-1,d7                 * Maximal 20 Zeichen
drmenn0:
 lea einbuf(a5),a0
 moveq #$11,d0
 move d6,d1
 bsr textein                    * Zeichen lesen
 bcs.s drmenn1                  * Ende
 tst d4
 beq.s drmenn1                  * Ende
 lea einbuf(a5),a0
 bsr wertmfeh                   * Wert berechnen
 bcs.s drmenn0                  * Fehler, noch einmal eingeben
 move.b d0,(a1)+                * Wert ablegen
 add #24,d6                     * Neue Position
dbra d7,drmenn0
drmenn1:
 st (a1)                        * Endekennung

drmenna:                        * Ausgabe der selbstdefinierten Befehle
 moveq #$11,d0                  * Schriftgre
 moveq #53,d1                   * X-Position
 moveq #77,d2                   * Y-Position
 bsr setprt                     * Werte einstellen
 bsr erapen                     * Auf Lschen
 moveq #%1010,d0                * Befehl fr Block
 moveq #76,d7                   * 30 Zeichen lschen
drmenna0:
 bsr cmd                        * Befehl an GDP
dbra d7,drmenna0
 bsr setpen
 lea drsave(a5),a1              * Dort stehen Druckerbefehle
drmenna1:
 lea ausbuf(a5),a0
 move.b (a1)+,d0                * Befehle holen
 cmp.b #$ff,d0                  * $ff ist Ende
 beq.s drmenna2
 bsr print2x                    * In hexadezimal wandeln
 lea ausbuf(a5),a0
 moveq #$11,d0
 bsr textprint                  * Zeichen ausgeben
 add #24,d1                     * Nchste Position
bra.s drmenna1                  * Wiederholen
drmenna2:
rts                             * Ende

drmenq:                         * Seitenvorschub
 moveq #$c,d0
bra lo2

drmenr:                         * Editor ausdrucken
 moveq #0,d2
 move.b dflag1(a5),d2
 lsr #5,d2                      * 3 Bit fr Anzahl
bra.s drmenr1
drmenr0:
 tst d3                         * Zeile Null ?
 beq.s drmenr1                  * Ja, dann kein Seitenvorschub
 bsr.s drmenq                   * Seitenvorschub
drmenr1:
 moveq #0,d3                    * Zeile Null
 movea.l stxtxt(a5),a1          * Anfangsadresse
drmenr2:
 move.b (a1)+,d1                * Zeichen holen
 beq.s drmenr5                  * Null ist Ende
 cmp.b #$a,d1                   * Linefeed ?
 bne.s drmenr3                  * Nein
 addq #1,d3                     * Nchste Zeile erreicht
 cmp.b dflag2(a5),d3            * Ende der Seite erreicht ?
 bne.s drmenr3                  * Nein, dann nur Linefeed ausfhren
 clr d3
 bsr.s drmenq                   * Ja, Seitenvorschub ausfhren
bra.s drmenr2                   * Nchstes Zeichen
drmenr3:
 bsr csts                       * Zeichen von Tastatur ?
 beq.s drmenr4                  * Nein !!!
 bsr ci                         * Zeichen holen
 cmp.b #$1b,d0
 beq carset                     * ESC = Abbruch
drmenr4:
 bsr lsts
 beq.s drmenr3                  * Warten bis Drucker fertig
 move.b d1,d0                   * Auszugebendes Zeichen
 bsr lo                         * Zeichen ausgeben
bra.s drmenr2                   * Nchstes Zeichen
drmenr5:
dbra d2,drmenr0                 * Kopien
bra carres

drbefneu:                       * Druckerbefehle ndern
 addq.l #4,a7                   * Rcksprungadresse lschen
 bsr clrall                     * Bildschirm lschen
 lea drtxt2(pc),a0              * Ausgabetext
 moveq #$21,d0
 moveq #2,d1
 move #245,d2
 bsr textprint
drbefn0:
 lea drtxt2(pc),a0              * Ausgabetext
 moveq #$21,d0
 moveq #2,d1
 move #245,d2
 bsr textprint
 lea drbeftab(a5),a1            * Tabelle der Druckerbefehle
 move #245,d2                   * Anfangs Y-Position
 move #360,d1                   * X-Position
 moveq #22-1,d7                 * Anzahl der Befehle
drbefn1:
 movea.l a1,a2                  * Adresse merken
 lea ausbuf(a5),a0              * Ziel
 move.l #'    ',(a0)+           * Vorlschen
 move.l #'    ',(a0)+
 move.l #'    ',(a0)+
 clr.b (a0)
 lea ausbuf(a5),a0              * Ziel
 moveq #3-1,d6                  * Maximal 3 Bytes pro Befehl
drbefn2:
 move.b (a2)+,d0                * Byte holen
 bmi.s drbefn3                  * Negativ, dann Ende
 bsr print2x                    * In ASCII wandeln
 move.b #' ',(a0)               * Null am Ende berschreiben
 addq.l #2,a0                   * Zieladresse erhhen
dbra d6,drbefn2
drbefn3:
 addq.l #3,a1                   * Adresse nchster Befehl
 moveq #$21,d0
 lea ausbuf(a5),a0
 bsr textaus                    * Text ausgeben
 sub #10,d2                     * Nchste Y-Position
dbra d7,drbefn1
drbefn4:
 lea einbuf(a5),a0
 moveq #$21,d0
 moveq #2,d1
 moveq #2,d2
 moveq #1,d3                    * Nur 1 Zeichen
 bsr textein                    * Befehl einlesen
 bcs druckmen                   * Abbruch
 move d5,d0
 bsr bucheck                    * In Grobuchstaben wandeln
 cmp.b #'Z',d0
 beq druckmen                   * 'Z' = Zurck
 cmp.b #'W',d0
 bne.s drbefn5                  * 'W' = Druckbefehle initialisieren
 bsr drbefinit
bra drbefn0
drbefn5:
 cmp.b #'A',d0                  * Bereich 'A'
 bmi.s drbefn4
 cmp.b #'V',d0                  * bis 'V'
 bhi.s drbefn4
 move d0,d2                     * Merken fr Y-Position
 mulu #3,d0                     * 3 Bytes pro Befehl
 lea drbeftab-3*'A'(a5),a4      * Tabelle der Befehle
 adda.l d0,a4                   * Ablageadresse errechnet
 muls #-10,d2                   * Zeilenabstand
 add #245+10*'A',d2             * Oberste Zeile
 move #360,d6                   * X-Position
 moveq #3-1,d7
drbefn6:
 moveq #$21,d0                  * Schriftgre
 move d6,d1
 moveq #3,d3                    * Maximal 3 Zeichen
 lea einbuf(a5),a0
 bsr textein                    * Zeichen einlesen
 bcs.s drbefn7                  * Abbruch
 tst d4
 beq.s drbefn7                  * Wenn kein Zeichen, dann Ende
 lea einbuf(a5),a0
 bsr wertmfeh                   * Wert berechnen
 bcs.s drbefn6                  * Fehler, noch einmal lesen
 tst d0
 bmi.s drbefn6                  * Negative Werte sind nicht erlaubt
 move.b d0,(a4)+                * Im Speicher ablegen
 add #12*4,d6                   * Nchste X-Position
dbra d7,drbefn6
bra drbefn0
drbefn7:
 st (a4)                        * Endekennung, da nicht 3 Zeichen
bra drbefn0
